format pe console 4.0
include 'win32a.inc'
include 'macro\if.inc'
entry main

macro pushdata label,[data] {
     common
	  __PUSHDATA_LAST equ label
	  __PUSHDATA_LIST equ
	 .len=0
	 .size=0
     forward
	  virtual
	       data
	      .len=.len+$-$$
	  end virtual
     common
	 .tlen=((3+.len) and (not 3))-(.len)
	 .part=0
     reverse
	 .ofst=0
	 .dlen=1
	  while .ofst<.dlen
	      .ofst=.ofst+4
	       virtual
		    rb 4
		    data
		    if .tlen > 0
			 db (.part shr 24) and 0xFF
		    end if
		    if .tlen > 1
			 db (.part shr 16) and 0xFF
		    end if
		    if .tlen > 2
			 db (.part shr 8) and 0xFF
		    end if
		   .dlen=$-$$-4
		    load .part DWORD from $-.ofst
	       end virtual
	       if .ofst<=.dlen
		    push .part
		   .size=.size+4
	       end if
	  end while
	 .pad=0
	 .tlen=4-((3+.dlen) and (not 3))+(.dlen)
	  if .tlen=4
	       .tlen=0
	  end if
     common
	locals
	  label dd ?
	endl
	  mov [label],esp
	  pushdata.#label#.size=.size
	  pushdata.#label#.length=.len
  __PUSHDATA_LAST_SIZE	 equ pushdata.#label#.size
  __PUSHDATA_LAST_LENGTH equ pushdata.#label#.length }

macro popdata {
  add esp,__PUSHDATA_LAST_SIZE
  restore __PUSHDATA_LAST_SIZE
  restore __PUSHDATA_LAST_LENGTH }

macro MIDL_INTERFACE value {
  match arg1-arg2-arg3-arg4-arg5,value \{
  dq 0x\#arg1 + (0x\#arg2 * 0x100000000) + (0x\#arg3 * 0x1000000000000),\
     (0x\#arg4 and 0x00FF)	   shl 8  + (0x\#arg4 and 0xFF00)	shr 8  +\
     (0x\#arg5 and 0xFF0000000000) shr 24 + (0x\#arg5 and 0xFF00000000) shr 8  +\
     (0x\#arg5 and 0xFF000000)	   shl 8  + (0x\#arg5 and 0xFF0000)	shl 24 +\
     (0x\#arg5 and 0xFF00)	   shl 40 + (0x\#arg5 and 0xFF) 	shl 56 \} }


EOAC_NONE		     = 0x00
RPC_C_IMP_LEVEL_IMPERSONATE  = 0x03
RPC_C_AUTHN_LEVEL_DEFAULT    = 0x00
RPC_C_AUTHN_LEVEL_PKT	     = 0x04
CLSCTX_INPROC_SERVER	     = 0x01
CLSCTX_LOCAL_SERVER	     = 0x04
WBEM_FLAG_RETURN_IMMEDIATELY = 0x10
WBEM_INFINITE		     = 0xFFFFFFFF

VT_EMPTY	    = 0
VT_NULL 	    = 1
VT_I2		    = 2
VT_I4		    = 3
VT_R4		    = 4
VT_R8		    = 5
VT_CY		    = 6
VT_DATE 	    = 7
VT_BSTR 	    = 8
VT_DISPATCH	    = 9
VT_ERROR	    = 10
VT_BOOL 	    = 11
VT_VARIANT	    = 12
VT_UNKNOWN	    = 13
VT_DECIMAL	    = 14
VT_I1		    = 16
VT_UI1		    = 17
VT_UI2		    = 18
VT_UI4		    = 19
VT_I8		    = 20
VT_UI8		    = 21
VT_INT		    = 22
VT_UINT 	    = 23
VT_VOID 	    = 24
VT_HRESULT	    = 25
VT_PTR		    = 26
VT_SAFEARRAY	    = 27
VT_CARRAY	    = 28
VT_USERDEFINED	    = 29
VT_LPSTR	    = 30
VT_LPWSTR	    = 31
VT_RECORD	    = 36
VT_FILETIME	    = 64
VT_BLOB 	    = 65
VT_STREAM	    = 66
VT_STORAGE	    = 67
VT_STREAMED_OBJECT  = 68
VT_STORED_OBJECT    = 69
VT_BLOB_OBJECT	    = 70
VT_CF		    = 71
VT_CLSID	    = 72
VT_VERSIONED_STREAM = 73
VT_BSTR_BLOB	    = 0xfff
VT_VECTOR	    = 0x1000
VT_ARRAY	    = 0x2000
VT_BYREF	    = 0x4000
VT_RESERVED	    = 0x8000
VT_ILLEGAL	    = 0xffff
VT_ILLEGALMASKED    = 0xfff
VT_TYPEMASK	    = 0xfff


WBEM_S_NO_ERROR = 0
WBEM_S_FALSE	= 1

struct VARIANT
  vt	     dw ?
  wReserved1 dw ?
  wReserved2 dw ?
  wReserved3 dw ?
  value      dq ?
ends

struct SAFEARRAYBOUND
  cElements  dd ?
  lLbound    dd ?
ends

struct SAFEARRAY
  cDims 	  dw ?
  fFeatures	  dw ?
  cbElements	  dd ?
  cLocks	  dd ?
  pvData	  dd ?
  rgsabound	  SAFEARRAYBOUND
ends

interface IWbemLocator,\
    QueryInterface,\		  ;0
    AddRef,\			  ;4
    Release,\			  ;8
    ConnectServer		  ;C

interface IWbemServices,\
    QueryInterface,\		  ;0
    AddRef,\			  ;4
    Release,\			  ;8
    OpenNamespace,\		  ;C
    CancelAsyncCall,\		  ;10
    QueryObjectSink,\		  ;14
    GetObject,\ 		  ;18
    GetObjectAsync,\		  ;1C
    PutClass,\			  ;20
    PutClassAsync,\		  ;24
    DeleteClass,\		  ;28
    DeleteClassAsync,\		  ;2C
    CreateClassEnum,\		  ;30
    CreateClassEnumAsync,\	  ;34
    PutInstance,\		  ;38
    PutInstanceAsync,\		  ;3C
    DeleteInstance,\		  ;40
    DeleteInstanceAsync,\	  ;44
    CreateInstanceEnum,\	  ;48
    CreateInstanceEnumAsync,\	  ;4C
    ExecQuery,\ 		  ;50
    ExecQueryAsync,\		  ;54
    ExecNotificationQuery,\	  ;58
    ExecNotificationQueryAsync,\  ;5C
    ExecMethod,\		  ;60
    ExecMethodAsync		  ;64

interface IEnumWbemClassObject,\
    QueryInterface,\		  ;0
    AddRef,\			  ;4
    Release,\			  ;8
    Reset,\			  ;C
    Next,\			  ;10
    NextAsync,\ 		  ;14
    Clone,\			  ;18
    Skip			  ;1C

interface IWbemClassObject,\
    QueryInterface,\		  ;0
    AddRef,\			  ;4
    Release,\			  ;8
    GetQualifierSet,\		  ;C
    Get,\			  ;10
    Put,\			  ;14
    Delete,\			  ;18
    GetNames,\			  ;1C
    BeginEnumeration,\		  ;20
    Next,\			  ;24
    EndEnumeration,\		  ;28
    GetPropertyQualifierSet,\	  ;2C
    Clone,\			  ;30
    GetObjectText,\		  ;34
    SpawnDerivedClass,\ 	  ;38
    SpawnInstance,\		  ;3C
    CompareTo,\ 		  ;40
    GetPropertyOrigin,\ 	  ;44
    InheritsFrom,\		  ;48
    GetMethod,\ 		  ;4C
    PutMethod,\ 		  ;50
    DeleteMethod,\		  ;54
    BeginMethodEnumeration,\	  ;58
    NextMethod,\		  ;5C
    EndMethodEnumeration,\	  ;60
    GetMethodQualifierSet,\	  ;64
    GetMethodOrigin		  ;68

section 'code' code data readable executable

proc main
		    call EthernetEnumInterfaces

		    pushdata pszAdapterName,db 'VMware Virtual Ethernet Adapter for VMnet1'\,0
		    pushdata pszIpAddressValue,db '192.168.1.17'\,0
		    pushdata pszSubnetMaskValue,db '255.255.255.0'\,0
			 stdcall EthernetSetParameters,[pszAdapterName],[pszIpAddressValue],[pszSubnetMaskValue]
		    popdata
		    popdata
		    popdata
		    invoke ExitProcess,0
		    ret
endp

proc EthernetSetParameters pszInterfaceName,pszIpAddressValue,pszSubnetMaskValue
		  locals
		    nReturnValue			       dd ?
		    isParametersValid			       dd ?
		    uszInterfaceName			       rw MAX_PATH
		    uszIpAddressValue			       rw MAX_PATH
		    uszSubnetMaskValue			       rw MAX_PATH
		    uszRootCimv2EthernetInterfaceInstanceValue rw MAX_PATH
		    WbemLocator 			       IWbemLocator
		    WbemServices			       IWbemServices
		    EnumWbemClassObject 		       IEnumWbemClassObject
		    WbemAdapterClass			       IWbemClassObject
		    WbemAdapterEnableStaticClass	       IWbemClassObject
		    WbemAdapterEnableStaticInstance	       IWbemClassObject
		    WbemAdapterEnableStaticInstanceOut	       IWbemClassObject
		    nReturned				       dd ?
		    variant				       VARIANT
		    nInterfaceIndex			       dd ?
		    pSafeArrayIp			       dd ?
		    pSafeArraySubnet			       dd ?
		    nIdx				       dd ?
		    puszWql				       dd ?
		    puszQuerySelect			       dd ?
		    puszDescription			       dd ?
		    puszIndex				       dd ?
		    puszWbemPath			       dd ?
		    puszNetworkAdapterConfiguration	       dd ?
		    puszEnableStatic			       dd ?
		    puszIpAddress			       dd ?
		    puszSubnetMask			       dd ?
		    puszIPAddressField			       dd ?
		    puszSubNetMaskField 		       dd ?
		    puszSubnetField			       dd ?
		    puszRootCimv2EthernetInterfaceInstance     dd ?
		  endl
		    mov [nReturnValue],FALSE
		    invoke lstrlenA,[pszInterfaceName]
		    inc eax
		    lea ecx,[uszInterfaceName]
		    invoke MultiByteToWideChar,CP_ACP,0,[pszInterfaceName],eax,ecx,MAX_PATH
		    invoke lstrlenA,[pszIpAddressValue]
		    inc eax
		    lea ecx,[uszIpAddressValue]
		    invoke MultiByteToWideChar,CP_ACP,0,[pszIpAddressValue],eax,ecx,MAX_PATH
		    invoke lstrlenA,[pszSubnetMaskValue]
		    inc eax
		    lea ecx,[uszSubnetMaskValue]
		    invoke MultiByteToWideChar,CP_ACP,0,[pszSubnetMaskValue],eax,ecx,MAX_PATH
		    invoke CoInitialize,0
		    invoke CoInitializeSecurity,0,-1,0,0,RPC_C_AUTHN_LEVEL_DEFAULT,RPC_C_IMP_LEVEL_IMPERSONATE,0,EOAC_NONE,0
		   .if eax <> 0
			 pushdata pszErrorCanNotInitializeSecurity,db 'ERROR: CoInitializeSecurity()<>0'\,0x0d\,0x0a\,0
			      stdcall printf,esp
			 popdata
		   .else
			 pushdata pbinCLSID_WbemLocator,MIDL_INTERFACE 4590f811-1d3a-11d0-891f-00aa004b2e24
			 pushdata pbinIID_WbemLocator,MIDL_INTERFACE dc12a687-737f-11cf-884d-00aa004b2e24
			      lea eax,[WbemLocator]
			      mov DWORD[eax],0
			      invoke CoCreateInstance,[pbinCLSID_WbemLocator],0,CLSCTX_INPROC_SERVER,[pbinIID_WbemLocator],eax
			 popdata
			 popdata
			.if eax <> 0
			      pushdata pszErrorCanNotCreateWbemLocator,db 'ERROR: CoCreateInstance()<>0'\,0x0d\,0x0a\,0
				   stdcall printf,esp
			      popdata
			.else
			      pushdata puszWbemPathValue,du 'ROOT\CIMV2'\,0
				   invoke SysAllocString,esp
				   mov [puszWbemPath],eax
			      popdata
			      lea eax,[WbemServices]
			      mov DWORD[eax],0
			      cominvk WbemLocator,ConnectServer,[puszWbemPath],0,0,0,0,0,0,eax
			     .if eax <> 0
				   pushdata pszErrorCanNotConnectServer,db 'ERROR: IWbemLocator.ConnectServer()<>0'\,0x0d\,0x0a\,0
					stdcall printf,esp
				   popdata
			     .else
				   mov [nInterfaceIndex],-1
				   pushdata puszIPAddressFieldValue,du 'IPAddress'\,0
					invoke SysAllocString,esp
					mov [puszIPAddressField],eax
				   popdata
				   pushdata puszSubNetMaskFieldValue,du 'SubNetMask'\,0
					invoke SysAllocString,esp
					mov [puszSubNetMaskField],eax
				   popdata
				   pushdata puszSubNetFieldValue,du 'IPSubnet'\,0
					invoke SysAllocString,esp
					mov [puszSubnetField],eax
				   popdata
				   pushdata pusWqlValue,du 'WQL'\,0
					invoke SysAllocString,esp
					mov [puszWql],eax
				   popdata
				   pushdata puszQuerySelectValue,du 'Select * from Win32_NetworkAdapterConfiguration where IPEnabled=TRUE'\,0
					invoke SysAllocString,esp
					mov [puszQuerySelect],eax
				   popdata
				   lea eax,[EnumWbemClassObject]
				   mov DWORD[eax],0
				   cominvk WbemServices,ExecQuery,[puszWql],[puszQuerySelect],WBEM_FLAG_RETURN_IMMEDIATELY,0,eax
				  .if eax <> 0
					pushdata pszErrorCanNotExecQuery,db 'ERROR: IWbemServices.ExecQuery()<>0'\,0x0d\,0x0a\,0
					     stdcall printf,esp
					popdata
				  .else
					cominvk EnumWbemClassObject,Reset
				       .if eax <> 0
					     pushdata pszErrorCanNotReset,db 'ERROR: IEnumWbemClassObject.Reset()<>0'\,0x0d\,0x0a\,0
						  stdcall printf,esp
					     popdata
				       .else
					     pushdata puszDescriptionValue,du 'Description'\,0
						  invoke SysAllocString,esp
						  mov [puszDescription],eax
					     popdata
					     pushdata puszIndexValue,du 'Index'\,0
						  invoke SysAllocString,esp
						  mov [puszIndex],eax
					     popdata
			     .next_adapter:  lea ecx,[WbemAdapterClass]
					     mov DWORD[ecx],0
					     lea edx,[nReturned]
					     cominvk EnumWbemClassObject,Next,WBEM_INFINITE,1,ecx,edx
					    .if eax <> WBEM_S_NO_ERROR & eax <> WBEM_S_FALSE
						  pushdata pszErrorCanNotNext,db 'ERROR: IEnumWbemClassObject.Next()<>0'\,0x0d\,0x0a\,0
						       stdcall printf,esp
						  popdata
					    .elseif eax = WBEM_S_FALSE
						  pushdata pszErrorCanNotFindAdapter,db 'ERROR: IEnumWbemClassObject does not contain the selected interface'\,0x0d\,0x0a\,0
						       stdcall printf,esp
						  popdata
					    .else
						  lea eax,[variant]
						  cominvk WbemAdapterClass,Get,[puszDescription],0,eax,0,0
						 .if eax <> 0 | WORD[variant.vt]<>VT_BSTR
						       pushdata pszErrorCanNotGetDescription,db 'ERROR: IWbemClassObject.Get("Description")<>0'\,0x0d\,0x0a\,0
							    stdcall printf,esp
						       popdata
						 .else
						       lea eax,[uszInterfaceName]
						       invoke lstrcmpW,eax,DWORD[variant.value]
						      .if eax <> 0
							    cominvk WbemAdapterClass,Release
							    jmp .next_adapter
						      .endif
						       mov [isParametersValid],FALSE
						       lea eax,[variant]
						       cominvk WbemAdapterClass,Get,[puszIPAddressField],0,eax,0,0
						      .if eax<>0 | [variant.vt]<>VT_BSTR+VT_ARRAY
							    pushdata pszErrorCanNotGetDescription,db 'ERROR: IWbemClassObject.Get("IPAddress")<>0'\,0x0d\,0x0a\,0
								 stdcall printf,esp
							    popdata
						      .else
							    mov [nIdx],0
						       @@:  mov edx,DWORD[variant.value]
							    mov eax,[nIdx]
							   .if eax < [edx + SAFEARRAY.rgsabound.cElements]
								 mov edx,[edx + SAFEARRAY.pvData]
								 mov ecx,[edx + eax*4]
								 lea eax,[uszIpAddressValue]
								 invoke lstrcmpW,ecx,eax
								.if eax <> 0
								      inc [nIdx]
								      jmp @B
								.endif
							   .endif
							    mov edx,DWORD[variant.value]
							    mov eax,[nIdx]
							   .if eax < [edx + SAFEARRAY.rgsabound.cElements]
								 lea eax,[variant]
								 cominvk WbemAdapterClass,Get,[puszSubnetField],0,eax,0,0
								.if eax<>0 | [variant.vt]<>VT_BSTR+VT_ARRAY
								      pushdata pszErrorCanNotGetDescription,db 'ERROR: IWbemClassObject.Get("SubNet")<>0'\,0x0d\,0x0a\,0
									   stdcall printf,esp
								      popdata
								.else
								      mov [nIdx],0
								 @@:  mov edx,DWORD[variant.value]
								      mov eax,[nIdx]
								     .if eax < [edx + SAFEARRAY.rgsabound.cElements]
									   mov edx,[edx + SAFEARRAY.pvData]
									   mov ecx,[edx + eax*4]
									   lea eax,[uszSubnetMaskValue]
									   invoke lstrcmpW,ecx,eax
									  .if eax <> 0
										inc [nIdx]
										jmp @B
									  .endif
								     .endif
								      mov edx,DWORD[variant.value]
								      mov eax,[nIdx]
								     .if eax < [edx + SAFEARRAY.rgsabound.cElements]
									   mov [isParametersValid],TRUE
									   mov [nReturnValue],TRUE
								     .endif
								.endif
							   .endif
						      .endif
						      .if [isParametersValid] = FALSE
							    lea eax,[variant]
							    cominvk WbemAdapterClass,Get,[puszIndex],0,eax,0,0
							   .if eax <> 0 | WORD[variant.vt]<>VT_I4
								 pushdata pszErrorCanNotGetDescription,db 'ERROR: IWbemClassObject.Get("Index")<>0'\,0x0d\,0x0a\,0
								      stdcall printf,esp
								 popdata
							   .else
								 mov eax,DWORD[variant.value]
								 mov [nInterfaceIndex],eax
							   .endif
						      .endif
						 .endif
						  cominvk WbemAdapterClass,Release
					    .endif
					     invoke SysFreeString,[puszIndex]
					     invoke SysFreeString,[puszDescription]
				       .endif
					cominvk EnumWbemClassObject,Release
				  .endif
				   invoke SysFreeString,[puszQuerySelect]
				   invoke SysFreeString,[puszWql]
				  .if [nInterfaceIndex] <> -1
					pushdata puszNetworkAdapterConfigurationValue,du 'Win32_NetworkAdapterConfiguration'\,0
					     invoke SysAllocString,esp
					     mov [puszNetworkAdapterConfiguration],eax
					popdata
					lea eax,[WbemAdapterClass]
					cominvk WbemServices,GetObject,[puszNetworkAdapterConfiguration],0,0,eax,0
				       .if eax <> 0
					     pushdata pszErrorCanNotGetObject,db 'ERROR: IWbemServices.GetObject("Win32_NetworkAdapterConfiguration")<>0'\,0x0d\,0x0a\,0
						  stdcall printf,esp
					     popdata
				       .else
					     pushdata puszEnableStaticValue,du 'EnableStatic'\,0
						  invoke SysAllocString,esp
						  mov [puszEnableStatic],eax
					     popdata
					     lea eax,[WbemAdapterEnableStaticClass]
					     mov DWORD[eax],0
					     cominvk WbemAdapterClass,GetMethod,[puszEnableStatic],0,eax,0
					    .if eax <> 0
						  pushdata pszErrorCanNotGetMethod,db 'ERROR: IWbemClassObject.GetMethod("EnableStatic")<>0'\,0x0d\,0x0a\,0
						       stdcall printf,esp
						  popdata
					    .else
						  lea eax,[WbemAdapterEnableStaticInstance]
						  mov DWORD[eax],0
						  cominvk WbemAdapterEnableStaticClass,SpawnInstance,0,eax
						  lea eax,[uszIpAddressValue]
						  invoke SysAllocString,eax
						  mov [puszIpAddress],eax
						  lea eax,[uszSubnetMaskValue]
						  invoke SysAllocString,eax
						  mov [puszSubnetMask],eax
						  invoke SafeArrayCreateVector,VT_BSTR,0,1
						  mov [pSafeArrayIp],eax
						  lea ecx,[nIdx]
						  mov DWORD[ecx],0
						  invoke SafeArrayPutElement,eax,ecx,[puszIpAddress]
						  mov eax,[pSafeArrayIp]
						  mov [variant.vt],VT_BSTR+VT_ARRAY
						  mov DWORD[variant.value],eax
						  lea eax,[variant]
						  cominvk WbemAdapterEnableStaticInstance,Put,[puszIPAddressField],0,eax,0
						  invoke SafeArrayCreateVector,VT_BSTR,0,1
						  mov [pSafeArraySubnet],eax
						  lea ecx,[nIdx]
						  mov DWORD[ecx],0
						  invoke SafeArrayPutElement,eax,ecx,[puszSubnetMask]
						  mov eax,[pSafeArraySubnet]
						  mov [variant.vt],VT_BSTR+VT_ARRAY
						  mov DWORD[variant.value],eax
						  lea eax,[variant]
						  cominvk WbemAdapterEnableStaticInstance,Put,[puszSubNetMaskField],0,eax,0
						  pushdata puszRootCimv2EthernetInterfaceInstanceMask,du '\\.\root\CIMV2:Win32_NetworkAdapterConfiguration.Index=%.8d'\,0
						       lea eax,[uszRootCimv2EthernetInterfaceInstanceValue]
						       invoke wsprintfW,eax,[puszRootCimv2EthernetInterfaceInstanceMask],[nInterfaceIndex]
						       add esp,3*4
						  popdata
						  lea eax,[uszRootCimv2EthernetInterfaceInstanceValue]
						  invoke SysAllocString,eax
						  mov [puszRootCimv2EthernetInterfaceInstance],eax
						  lea eax,[WbemAdapterEnableStaticInstanceOut]
						  mov DWORD[eax],0
						  cominvk WbemServices,ExecMethod,[puszRootCimv2EthernetInterfaceInstance],[puszEnableStatic],0,0,[WbemAdapterEnableStaticInstance],eax,0
						 .if eax <> 0
						       pushdata pszErrorCanNotExecMethod,db 'ERROR: IWbemServices.ExecMethod("EnableStatic")<>0'\,0x0d\,0x0a\,0
							    stdcall printf,esp
						       popdata
						 .else
						       mov [nReturnValue],TRUE
						 .endif
						  invoke SysFreeString,[puszRootCimv2EthernetInterfaceInstance]
						  invoke SafeArrayDestroy,[pSafeArraySubnet]
						  invoke SafeArrayDestroy,[pSafeArrayIp]
						  invoke SysFreeString,[puszSubnetMask]
						  invoke SysFreeString,[puszIpAddress]
						  cominvk WbemAdapterEnableStaticClass,Release
					    .endif
					     invoke SysFreeString,[puszEnableStatic]
					     cominvk WbemAdapterClass,Release
				       .endif
					invoke SysFreeString,[puszNetworkAdapterConfiguration]
				  .endif
				   invoke SysFreeString,[puszSubnetField]
				   invoke SysFreeString,[puszSubNetMaskField]
				   invoke SysFreeString,[puszIPAddressField]
				   cominvk WbemServices,Release
			     .endif
			      invoke SysFreeString,[puszWbemPath]
			      cominvk WbemLocator,Release
			.endif
		   .endif
		    invoke CoUninitialize
		    mov eax,[nReturnValue]
		    ret
endp

proc EthernetEnumInterfaces
		  locals
		    szDescriptionValue			       rb MAX_PATH
		    WbemLocator 			       IWbemLocator
		    WbemServices			       IWbemServices
		    EnumWbemClassObject 		       IEnumWbemClassObject
		    WbemAdapterClass			       IWbemClassObject
		    variant				       VARIANT
		    nReturned				       dd ?
		    puszWbemPath			       dd ?
		    puszWql				       dd ?
		    puszQuerySelect			       dd ?
		    puszDescription			       dd ?
		  endl
		    invoke CoInitialize,0
		    invoke CoInitializeSecurity,0,-1,0,0,RPC_C_AUTHN_LEVEL_DEFAULT,RPC_C_IMP_LEVEL_IMPERSONATE,0,EOAC_NONE,0
		   .if eax <> 0
			 pushdata pszErrorCanNotInitializeSecurity,db 'ERROR: CoInitializeSecurity()<>0'\,0x0d\,0x0a\,0
			      stdcall printf,esp
			 popdata
		   .else
			 pushdata pbinCLSID_WbemLocator,MIDL_INTERFACE 4590f811-1d3a-11d0-891f-00aa004b2e24
			 pushdata pbinIID_WbemLocator,MIDL_INTERFACE dc12a687-737f-11cf-884d-00aa004b2e24
			      lea eax,[WbemLocator]
			      mov DWORD[eax],0
			      invoke CoCreateInstance,[pbinCLSID_WbemLocator],0,CLSCTX_INPROC_SERVER,[pbinIID_WbemLocator],eax
			 popdata
			 popdata
			.if eax <> 0
			      pushdata pszErrorCanNotCreateWbemLocator,db 'ERROR: CoCreateInstance()<>0'\,0x0d\,0x0a\,0
				   stdcall printf,esp
			      popdata
			.else
			      pushdata puszWbemPathValue,du 'ROOT\CIMV2'\,0
				   invoke SysAllocString,esp
				   mov [puszWbemPath],eax
			      popdata
			      lea eax,[WbemServices]
			      mov DWORD[eax],0
			      cominvk WbemLocator,ConnectServer,[puszWbemPath],0,0,0,0,0,0,eax
			     .if eax <> 0
				   pushdata pszErrorCanNotConnectServer,db 'ERROR: IWbemLocator.ConnectServer()<>0'\,0x0d\,0x0a\,0
					stdcall printf,esp
				   popdata
			     .else
				   pushdata pusWqlValue,du 'WQL'\,0
					invoke SysAllocString,esp
					mov [puszWql],eax
				   popdata
				   pushdata puszQuerySelectValue,du 'Select * from Win32_NetworkAdapterConfiguration where IPEnabled=TRUE'\,0
					invoke SysAllocString,esp
					mov [puszQuerySelect],eax
				   popdata
				   lea eax,[EnumWbemClassObject]
				   mov DWORD[eax],0
				   cominvk WbemServices,ExecQuery,[puszWql],[puszQuerySelect],WBEM_FLAG_RETURN_IMMEDIATELY,0,eax
				  .if eax <> 0
					pushdata pszErrorCanNotExecQuery,db 'ERROR: IWbemServices.ExecQuery()<>0'\,0x0d\,0x0a\,0
					     stdcall printf,esp
					popdata
				  .else
					cominvk EnumWbemClassObject,Reset
				       .if eax <> 0
					     pushdata pszErrorCanNotReset,db 'ERROR: IEnumWbemClassObject.Reset()<>0'\,0x0d\,0x0a\,0
						  stdcall printf,esp
					     popdata
				       .else
					     pushdata puszDescriptionValue,du 'Description'\,0
						  invoke SysAllocString,esp
						  mov [puszDescription],eax
					     popdata
			     .next_adapter:  lea ecx,[WbemAdapterClass]
					     mov DWORD[ecx],0
					     lea edx,[nReturned]
					     cominvk EnumWbemClassObject,Next,WBEM_INFINITE,1,ecx,edx
					    .if eax <> WBEM_S_NO_ERROR & eax <> WBEM_S_FALSE
						  pushdata pszErrorCanNotNext,db 'ERROR: IEnumWbemClassObject.Next()<>0'\,0x0d\,0x0a\,0
						       stdcall printf,esp
						  popdata
					    .elseif eax = WBEM_S_NO_ERROR
						  lea eax,[variant]
						  cominvk WbemAdapterClass,Get,[puszDescription],0,eax,0,0
						 .if eax <> 0 | WORD[variant.vt]<>VT_BSTR
						       pushdata pszErrorCanNotGetDescription,db 'ERROR: IWbemClassObject.Get("Description")<>0'\,0x0d\,0x0a\,0
							    stdcall printf,esp
						       popdata
						 .else

						       invoke lstrlenW,DWORD[variant.value]
						       inc eax
						       lea ecx,[szDescriptionValue]
						       invoke WideCharToMultiByte,CP_ACP,0,DWORD[variant.value],eax,ecx,MAX_PATH,0,0
						       pushdata pszAdapterOutputMask,db '%s'\,0x0d\,0x0a\,0
							    lea eax,[szDescriptionValue]
							    stdcall printf,[pszAdapterOutputMask],eax
						       popdata

						       cominvk WbemAdapterClass,Release
						       jmp .next_adapter
						 .endif
					    .endif
					     invoke SysFreeString,[puszDescription]
				       .endif
					cominvk EnumWbemClassObject,Release
				  .endif
				   invoke SysFreeString,[puszQuerySelect]
				   invoke SysFreeString,[puszWql]
				   cominvk WbemServices,Release
			     .endif
			      invoke SysFreeString,[puszWbemPath]
			      cominvk WbemLocator,Release
			.endif
		   .endif
		    invoke CoUninitialize
		    ret
endp

proc printf
		  locals
		    nArguments	    dd ?
		    hStdOutput	    dd ?
		    nBytesWritten   dd ?
		    szMessageBuffer rb MAX_PATH
		  endl
		  virtual at ebp
		    binOldEbpValue   dd ?
		    binReturnAddress dd ?
		    pszMask	     dd ?
		    binArguments     dd ?
		  end virtual
		    xor eax,eax
		    mov [nArguments],eax
		    invoke lstrlenA,[pszMask]
		    mov ecx,eax
		    mov edx,[pszMask]
	       @@:  mov al,BYTE[edx]
		    inc edx
		   .if al = '%'
			 inc [nArguments]
		   .endif
		    loop @B
		    lea eax,[binArguments]
		    mov ecx,[nArguments]
		   .if ecx > 0
			 lea eax,[eax + ecx*4 - 4]
		     @@: push DWORD[eax]
			 sub eax,4
			 loop @B
		   .endif
		    lea eax,[szMessageBuffer]
		    invoke wsprintfA,eax,[pszMask]
		    mov eax,[nArguments]
		    lea eax,[eax*4 + 2*4]
		    add esp,eax
		    invoke GetStdHandle,STD_OUTPUT_HANDLE
		    mov [hStdOutput],eax
		    lea eax,[szMessageBuffer]
		    invoke lstrlenA,eax
		    lea ecx,[nBytesWritten]
		    lea edx,[szMessageBuffer]
		    invoke WriteFile,[hStdOutput],edx,eax,ecx,0
		    mov eax,[nArguments]
		    lea eax,[eax*4 + 2*4]
		    leave
		    mov ecx,[esp]
		    add esp,eax
		    jmp ecx
endp

section 'data' data readable writable
data import
library kernel32,'kernel32.dll',user32,'user32.dll',ole32,'ole32.dll',oleaut32,'oleaut32.dll'
include 'api\kernel32.inc'
include 'api\user32.inc'
import ole32,\
       CoInitialize,'CoInitialize',\
       CoInitializeSecurity,'CoInitializeSecurity',\
       CoCreateInstance,'CoCreateInstance',\
       CoUninitialize,'CoUninitialize'
import oleaut32,\
       SysAllocString,'SysAllocString',\
       SysFreeString,'SysFreeString',\
       SafeArrayCreateVector,'SafeArrayCreateVector',\
       SafeArrayPutElement,'SafeArrayPutElement',\
       SafeArrayDestroy,'SafeArrayDestroy'
end data